
import java.lang.*;
import java.awt.*;
import java.awt.image.*;
import java.applet.*;
import java.io.*;

public class app{

  public static globals mainglobals;
  public static sactblsh temp;
  public static int a;
  public static String args[];
  public static Image img;
  public static MemoryImageSource source;
  public static Graphics g;
  
  public static void init(){
    
    boolean res;
    
    System.out.println("Initialising decoder.");
    
    resize(176, 144);

    mainglobals = new globals();
    
    mainglobals.initGlobals();

    mainglobals.cmodel = getColorModel();
    
    source = new MemoryImageSource(176, 
				   144,
				   getColorModel(),
				   mainglobals.pix, 0, 
				   176);
    
    res = false;
    
    args = new String[10];
    for (int i = 0; i < 10; i++)
      args[i] = new String();
        
    System.out.println("Finished initialising globals.");
    
  }

  public static void start(){

   System.out.println("In start");
   
   if (mainglobals.kicker == null){
     mainglobals.kicker = new Thread(this);
     mainglobals.kicker.start();
   }
   
 }
  
  public static void stop(){
    
   System.out.println("In stop.");
   if (mainglobals.kicker != null){
       mainglobals.kicker.stop();
       mainglobals.kicker = null;
   }

  }

  public static void paint(Graphics g){

   System.out.println("************ IN PAINT *************");
   g.drawImage(img, 0, 0, 176, 144, this);

  }




  public static void run(){

    int len;
    String temp;
    int first, framenum[];
    
    System.out.println("In run.");
    
    framenum = new int[1];
    args[0] = "cla7.263";
    args[1] = "cla7.out";
    
    mainglobals.NPACH263Dec.options(args);
    
    temp = args[args.length - 1];
    len = temp.length();
    
    mainglobals.outputname = new StringBuffer(len);
    mainglobals.outputname.append(temp);
    
    try{
      mainglobals.ld.infile = new FileInputStream("/home/A6D/avneesh/TOOLS/H263/DECODER/JAVA/cla7.263");
    }
    catch(Exception e){
      System.out.println("File " + args[0] + " not found.");
      System.exit(1);
    }
    
    first = 1;
    g = getGraphics();

    do{
      mainglobals.NPACGetBits.initbits();
      framenum[0] =mainglobals.tr_framenum[0] = 0;
      
      while (mainglobals.NPACGetHdr.getheader() != 0){
        if (first != 0){
          mainglobals.NPACH263Dec.initdecoder();
          first = 0;
        }
	
	mainglobals.NPACGetPic.getpicture(framenum);
        framenum[0]++;
	mainglobals.tr_framenum[0]++;					  
	img = createImage(source);
	img.flush();
	g.drawImage(img, 0, 0, 176, 144, this);
      }
      System.out.println("Decoded sequence.");
    } while(mainglobals.kicker != null);
    
    try{
      mainglobals.ld.infile.close();
    }
    catch(Exception e){}
  }
  
  public static void main(String args[]){


    init();
    run();
    
  }

}
